const system = require("../../../system");
var settings = require("../../../../config/settings");
const querystring = require('querystring');
const AppServiceBase = require("../../app.base");
class UtilsPushService extends AppServiceBase {
  constructor() {
    super();
    this.pushlogSve = system.getObject("service.common.pushlogSve");
  };

  async aliBusiness2Fq(pobj, opType) {//供业务调用，在代码中调用，不在db中做配置进行调用
    pobj.actionType = "getAppInterface";
    var reqUrl = settings.centerAppUrl() + "action/opProduct/springBoard";
    var productItemInterfaceResult = await this.restPostUrl(pobj, reqUrl);
    pobj.interface_info = productItemInterfaceResult.data;
    this.pushBusInfo(pobj, opType, 1);
  }

  async pushBusInfo(pobj, opType, isDelProductInfo) {//推送业务总入口-包括重试
    var interface_list = pobj.interface_info ? pobj.interface_info : pobj.actionBody.product_info.interface_info;
    if (!interface_list) {
      return system.getResult(null, "暂无推送配置");
    }
    var interface_list_temp = interface_list.filter(f => f.op_type == opType)
    if (!interface_list_temp || interface_list_temp.length == 0) {
      return system.getResult(null, "暂无【" + opType + "】的推送配置");
    }
    for (let index = 0; index < interface_list_temp.length; index++) {
      const element = interface_list_temp[index];
      this.reflexAction(element, opType, pobj, isDelProductInfo);
    }
  }
  async reflexAction(interface_info, opType, pobj, isDelProductInfo) {
    var refResult = null;
    pobj.interface_info = interface_info;
    pobj.opType = opType;
    pobj.isDelProductInfo = isDelProductInfo;
    try {
      if (interface_info.interface_type == "bd") {
        if (!interface_info.method_name) {
          return system.getResult(null, "产品接口参数信息有误，100350");
        }//操作的方法名称
        var invokeObj = system.getObject(interface_info.interface_url);
        if (!invokeObj[interface_info.method_name]) {
          return system.getResult(null, "产品接口参数方法信息有误，100360");
        }
        pobj.interface_params = interface_info.params;
        var params = [pobj];
        invokeObj[interface_info.method_name].apply(invokeObj, params);
      }
      else if (interface_info.interface_type == "yc") {
        var actionBody = pobj.actionBody;
        if (!interface_info.interface_url) {
          return system.getResult(null, "产品接口interface_url参数不能为空，100370");
        }
        if (actionBody.product_info && actionBody.product_info.price_list) {
          delete actionBody.product_info["price_list"];
        }
        if (actionBody.product_info && actionBody.product_info.interface_info) {
          delete actionBody.product_info["interface_info"];
        }
        if (isDelProductInfo && isDelProductInfo == 1 && actionBody.product_info) {
          delete actionBody["product_info"];
        }//是否删除产品信息进行推送
        refResult = await this.restPostUrl(pobj.actionBody, interface_info.interface_url);

        this.pushlogSve.createDb({
          appid: pobj.appInfo.uapp_id,
          appkey: pobj.appInfo.uapp_key,
          op: JSON.stringify(pobj.interface_info),//推送的接口信息
          content: JSON.stringify(pobj),//推送的参数信息
          resultInfo: JSON.stringify(rtn),
          returnType: refResult.status == 0 ? '1' : '0',
          opTitle: opType + (refResult.status == 0 ? "数据推送成功->reflexAction" : "数据推送出错->reflexAction")
        });
      }
      return system.getResultSuccess();
    } catch (e) {
      this.pushlogSve.createDb({
        appid: pobj.appInfo.uapp_id,
        appkey: pobj.appInfo.uapp_key,
        op: JSON.stringify(pobj.interface_info),//推送的接口信息
        content: JSON.stringify(pobj),//推送的参数信息
        resultInfo: "",
        returnType: '0',
        opTitle: opType + "数据推送异常-->reflexAction"
      });
    }
  }
}
module.exports = UtilsPushService;
